/***********************************************************************
*
* Macro.h: Macro
*
* Modifications:
*
* 20-05-2003/Maup: First release
*
***********************************************************************/

#ifndef __MACRO__
#define __MACRO__

#include "Types.h"

/* Some values */
#define 	FULL			0xFF
#define		ZERO			0x00

#define 	ON				1
#define 	OFF				0

#define		HIGH			TRUE
#define		LOW				FALSE

/* Some assembler instruction */
#define		Halt		asm ("halt")
#define		Nop			asm ("nop")
#define		DisINT		asm ("clrb    %stat,#5")
#define		EnaINT		asm ("setb    %stat,#5")

#define   DisWdog() {asm("move RegWDSys,#0x47");\
asm ("move RegWDKey,#0x96");\
asm ("move RegWDSys,#0x07");}


 

/* Some rules */
#define	BIT7			0x80
#define	BIT6			0x40
#define	BIT5			0x20
#define	BIT4			0x10
#define	BIT3			0x08
#define	BIT2			0x04
#define	BIT1			0x02
#define	BIT0			0x01

/* Set a bit in a byte */
/* SetBit (Reg,BIT0); */
#define		SetBit(byte1,byte2)	  byte1 |= byte2

/* Clear a bit in a byte */
/* ClrBit (Reg,BIT0); */
#define		ClrBit(byte1,byte2)	  byte1 ^= byte2

/* Set a register with a bit value */
/* Reg = BIT0; */
#define   SetReg(byte1,byte2)      byte1 = byte2

/* Clear a register */
/* Reg = 0x00; */
#define		ClrReg(byte)			byte = ZERO

/* Fill in a register */
/* Reg = 0xFF; */
#define		FillReg(byte)			byte = FULL

/* Macro for indexed writing */
/* WritePeriph(18,40,1); // value=18, offset=40, high=1 */
#define   WritePeriph(val,offset,high)  {asm ("move  -(%i3),%i1h");\
asm ("move  -(%i3),%i1l");\
asm ("move  %i1h,#"#high"");\
asm ("move  %i1l,#0");\
asm ("move  %a,#"#val"");\
asm ("move  (%i1,"#offset "),%a");\
asm ("move  %i1l,(%i3)+");\
asm ("move  %i1h,(%i3)+");}

#define delay   Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;\
                Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;\
                Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;\
                Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;\
                Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;Nop;\

#endif /* __MACRO__ */
