/**********************************************************************
*
* Types.h: Types definition for C syntax
*
* Modifications:
*
* 20-05-2003/Maup: First release
*
***********************************************************************/


#ifndef __TYPES__
#define __TYPES__

/***************************************************************
* C Types for syntax definition
***************************************************************/

typedef unsigned char   UINT8;
typedef	signed char		SINT8;
typedef	unsigned int	UINT16;
typedef	signed int		SINT16;
typedef	float		    FLOAT24;


/********************************************************************
* Programmer special for current project
********************************************************************/

typedef unsigned char   UBYTE;
typedef signed char     BYTE;
typedef unsigned int    UINT;

#define RegUpdate(reg, mask, value) reg = (reg & ~mask) | value
#define RegSet(reg, value) reg = value
#define	RegSetBit(reg, value) reg |= value
#define	RegClrBit(reg, value) reg &= ~value
#define	RegClr(reg) reg = 0x00
#define	RegFill(reg) reg = 0xff

enum eBitMask { eB0 = 0x01, eB1 = 0x02, eB2 = 0x04, eB3 = 0x08,
             eB4 = 0x10, eB5 = 0x20, eB6 = 0x40, eB7 = 0x80 };
typedef enum eBitMask MaskType;

enum eBitSHR { eB0SHR = 0, eB1SHR, eB2SHR, eB3SHR,
				 eB4SHR, eB5SHR, eB6SHR, eB7SHR };
typedef enum eBitSHR BitSHRType;

enum eBitSHL { eB0SHL = 0, eB1SHL, eB2SHL, eB3SHL,
				 eB4SHL, eB5SHL, eB6SHL, eB7SHL };
typedef enum eBitSHL BitSHLType;

enum eBitPos { eB0Pos = 0, eB1Pos, eB2Pos, eB3Pos,
				 eB4Pos, eB5Pos, eB6Pos, eB7Pos };
typedef enum eBitPos BitPosType;



typedef void (*pfnType)(void);
typedef void (*pv0fnType)(void);
typedef void (*pv1ufnType)(UBYTE);
typedef UBYTE (*pu0fnType)(void);
typedef UBYTE (*pu1ufnType)(UBYTE);
typedef UBYTE (*pu1u1pvfnType)(UBYTE, void*);
typedef void* (*ppv0fnType)(void);
typedef void* (*ppv1ufnType)(UBYTE);

#endif /* __TYPES__ */
