//*************************************************************************
// App:      EM6812 Soft UART / Monitor
// Version:  1.0 
// Date:     
// Author:   EM Microelectronic
//*************************************************************************


#ifndef __Main_c__
#define __Main_c__

unsigned char volatile vUART_CNT;
unsigned char volatile vUART_STAT;
unsigned char volatile vUART_BYTE;    
unsigned char volatile vCMD;
unsigned int AD_VALUE;
unsigned int* pAD_VALUE;
typedef struct {
  unsigned char AD_VALUE_HIGH;
  unsigned char AD_VALUE_LOW;
  unsigned char DATA_VALUE; 
} tTARGET_REG;
tTARGET_REG ACCESS_REG;

#define cUARTBits     8           // Nr of bits 
#define cUART1Bit     0x0d        // 32768/14 = 1bit @2341bps
#define cUART15Bit    0x12        // Length of 1.5bits
#define cUART_RDY     0x01        // Ready
#define cUART_RX      0x02        // Receiving
#define cUART_RXD     0x03        // Received
#define cUART_TX      0x04        // Transmitting
#define cUART_IDLE    0x09        // Idle and ready
#define cRXPIN_MSK    0x80        // UART RX pin
#define cTXPIN_MSK    0x40        // UART TX pin
#define cCMD_W_AD     0x80        // write address register value                             
#define cCMD_R_AD     0x81        // read address register value
#define cCMD_W_DATA   0x82        // write data register value
#define cCMD_R_DATA   0x83        // read data register value
#define cCMD_UPDATE   0x84        // update pointed register (AD) with data (DATA) 
#define cCMD_DUMP     0x85        // dump pointer register content
 
int main(void);
void SysInterrupt1Dispatch(unsigned char RegInt);// Priority level 1
void SysInterrupt2Dispatch(unsigned char RegInt);// Priority level 2
void SysInterrupt0Dispatch(unsigned char RegInt);// Priority level 2
void SendUART(unsigned char Val, unsigned char TXStatus);
unsigned char GetUART(void);
void ExecCommand (unsigned char Command_name);
void SetHighSpeed(void);
void SetLowSpeed(void);

#endif /* __Main_c__ */
